/* tslint:disable */
import * as wasm from './sourmash_bg';

const u32CvtShim = new Uint32Array(2);

const uint64CvtShim = new BigUint64Array(u32CvtShim.buffer);

let cachegetUint32Memory = null;
function getUint32Memory() {
    if (cachegetUint32Memory === null || cachegetUint32Memory.buffer !== wasm.memory.buffer) {
        cachegetUint32Memory = new Uint32Array(wasm.memory.buffer);
    }
    return cachegetUint32Memory;
}

let cachedGlobalArgumentPtr = null;
function globalArgumentPtr() {
    if (cachedGlobalArgumentPtr === null) {
        cachedGlobalArgumentPtr = wasm.__wbindgen_global_argument_ptr();
    }
    return cachedGlobalArgumentPtr;
}

let cachegetUint64Memory = null;
function getUint64Memory() {
    if (cachegetUint64Memory === null || cachegetUint64Memory.buffer !== wasm.memory.buffer) {
        cachegetUint64Memory = new BigUint64Array(wasm.memory.buffer);
    }
    return cachegetUint64Memory;
}

let cachedTextEncoder = new TextEncoder('utf-8');

let cachegetUint8Memory = null;
function getUint8Memory() {
    if (cachegetUint8Memory === null || cachegetUint8Memory.buffer !== wasm.memory.buffer) {
        cachegetUint8Memory = new Uint8Array(wasm.memory.buffer);
    }
    return cachegetUint8Memory;
}

let WASM_VECTOR_LEN = 0;

function passStringToWasm(arg) {

    const buf = cachedTextEncoder.encode(arg);
    const ptr = wasm.__wbindgen_malloc(buf.length);
    getUint8Memory().set(buf, ptr);
    WASM_VECTOR_LEN = buf.length;
    return ptr;
}

let cachedTextDecoder = new TextDecoder('utf-8');

function getStringFromWasm(ptr, len) {
    return cachedTextDecoder.decode(getUint8Memory().subarray(ptr, ptr + len));
}

function freeKmerMinHash(ptr) {

    wasm.__wbg_kmerminhash_free(ptr);
}
/**
*/
export class KmerMinHash {

    free() {
        const ptr = this.ptr;
        this.ptr = 0;
        freeKmerMinHash(ptr);
    }

    /**
    * @returns {number}
    */
    get num() {
        return wasm.__wbg_get_kmerminhash_num(this.ptr);
    }
    set num(arg0) {
        return wasm.__wbg_set_kmerminhash_num(this.ptr, arg0);
    }
    /**
    * @returns {number}
    */
    get ksize() {
        return wasm.__wbg_get_kmerminhash_ksize(this.ptr);
    }
    set ksize(arg0) {
        return wasm.__wbg_set_kmerminhash_ksize(this.ptr, arg0);
    }
    /**
    * @returns {boolean}
    */
    get is_protein() {
        return (wasm.__wbg_get_kmerminhash_is_protein(this.ptr)) !== 0;
    }
    set is_protein(arg0) {
        return wasm.__wbg_set_kmerminhash_is_protein(this.ptr, arg0);
    }
    /**
    * @returns {BigInt}
    */
    get seed() {
        const retptr = globalArgumentPtr();
        wasm.__wbg_get_kmerminhash_seed(retptr, this.ptr);
        return getUint64Memory()[retptr / 8];

    }
    set seed(arg0) {

        uint64CvtShim[0] = arg0;
        const low0 = u32CvtShim[0];
        const high0 = u32CvtShim[1];

        return wasm.__wbg_set_kmerminhash_seed(this.ptr, low0, high0);
    }
    /**
    * @returns {BigInt}
    */
    get max_hash() {
        const retptr = globalArgumentPtr();
        wasm.__wbg_get_kmerminhash_max_hash(retptr, this.ptr);
        return getUint64Memory()[retptr / 8];

    }
    set max_hash(arg0) {

        uint64CvtShim[0] = arg0;
        const low0 = u32CvtShim[0];
        const high0 = u32CvtShim[1];

        return wasm.__wbg_set_kmerminhash_max_hash(this.ptr, low0, high0);
    }
    /**
    * @param {number} arg0
    * @param {number} arg1
    * @param {boolean} arg2
    * @param {number} arg3
    * @param {number} arg4
    * @param {boolean} arg5
    * @returns {}
    */
    constructor(arg0, arg1, arg2, arg3, arg4, arg5) {
        this.ptr = wasm.kmerminhash_new_with_scaled(arg0, arg1, arg2, arg3, arg4, arg5);
    }
    /**
    * @param {string} arg0
    * @returns {void}
    */
    add_sequence_js(arg0) {
        const ptr0 = passStringToWasm(arg0);
        const len0 = WASM_VECTOR_LEN;
        try {
            return wasm.kmerminhash_add_sequence_js(this.ptr, ptr0, len0);

        } finally {
            wasm.__wbindgen_free(ptr0, len0 * 1);

        }

    }
    /**
    * @returns {string}
    */
    to_json() {
        const retptr = globalArgumentPtr();
        wasm.kmerminhash_to_json(retptr, this.ptr);
        const mem = getUint32Memory();
        const rustptr = mem[retptr / 4];
        const rustlen = mem[retptr / 4 + 1];

        const realRet = getStringFromWasm(rustptr, rustlen).slice();
        wasm.__wbindgen_free(rustptr, rustlen * 1);
        return realRet;

    }
}

export function __wbindgen_throw(ptr, len) {
    throw new Error(getStringFromWasm(ptr, len));
}

